#!/bin/bash
##########################################################################################
#                                  QZ Tray MacOS Packager                                #
##########################################################################################
#  Description:                                                                          #
#    1. Packages software into an Apple pkg installer                                    #
#                                                                                        #
#  Depends:                                                                              #
#    pkgbuild, security                                                                  #
#                                                                                        #
#  Usage:                                                                                #
#    $ chmod +x apple-packager.sh                                                   #
#    $ ./apple-packager.sh                                                          #
#                                                                                        #
##########################################################################################
echo
echo "============================================"
echo "            Packaging QZ Tray"
echo "============================================"
echo
chmod +x "/Applications/MAMP/htdocs/qztray/out/dist/auth/apple-keygen.sh"

# Add signing certificate
security add-certificates "/Applications/MAMP/htdocs/qztray/ant/apple/apple-certificate.cer"
security add-certificates "/Applications/MAMP/htdocs/qztray/ant/apple/apple-intermediate.cer"

# Checks if we have an Apple code signing cert
security find-identity -v |grep "(P5DMU6659X)"

if [ $? ==  0 ]; then
	signing="--sign \"P5DMU6659X\""
	suffix=""
else
	signing=""
	suffix="-unsigned"
fi

eval "pkgbuild --identifier \"qz-tray\" \
	--root \"/Applications/MAMP/htdocs/qztray/out/dist\" \
	--install-location \"/Applications/QZ Tray.app\" \
	--scripts \"/Applications/MAMP/htdocs/qztray/out/build/scripts\" \
	--version \"2.0.4\" \
	${signing}\
	\"/Applications/MAMP/htdocs/qztray/out/qz-tray-community-2.0.4${suffix}.pkg\""
code=$?

echo
echo "============================================"
echo "                 Finished                   "
echo "============================================"
echo
exit $code
